/**
	CVMath wb_t@C
	06/Jun/2009 wb_t@Cƈ̎QƉ
*/
#pragma once

#ifndef _USE_MATH_DEFINES
#define _USE_MATH_DEFINES
#endif
#include <cmath>
#include <cstdlib>

#include <opencv/cv.h>
#include <opencv/cxcore.h>
#include <opencv/highgui.h>


#ifdef CVMATH_LINK_LIBS_210
#pragma comment(lib, "cv210.lib")
#pragma comment(lib, "cxcore210.lib")
#endif


#ifdef CVMATH_LINK_LIBS_220
#pragma comment(lib, "opencv_core220.lib")
#endif


//#include <iostream>
//using namespace std;
namespace opencv
{
namespace cvmath
{

	/**	radian  degree ɕϊ	*/
	inline double rad2deg(double rad){	return 180.0 * rad / M_PI;	}

	/**	lower`upper̈l̐	*/
	inline double sampleUniform(double lower = 0.0, double upper = 1.0){	return lower + (upper - lower) * (double) rand() / (double) RAND_MAX;	}

	/**	 m, W΍ s 1K̐	*/
	inline double sampleNormal1D(double m, double s){
		double u;
		while(!(u = sampleUniform(0, 1)));
		return m + s * sqrt(-2*log(u)) * cos(sampleUniform(0, 2 * M_PI));
	}

	/**	2WK̐	*/
	inline void sampleNormal2D(double *x, double *y){
		double u;
		while(!(u = sampleUniform(0, 1)));
		double theta = sampleUniform(0, 2 * M_PI);

		double r = sqrt(-2*log(u));

		if(x) *x = r * cos(theta);
		if(y)	*y = r * sin(theta);
	}

	/**	degree  radian ɕϊ	*/
	inline double deg2rad(double deg){	return M_PI * deg / 180.0;	}

}
}

#include "cvmttype.h"
#include "cvmtvector.h"
#include "cvmtmatrix.h"
#include "cvmtq8n.h"
//#include "cvmteigen.h"