#pragma once


#include <opencv/cv.h>


namespace opencv
{
namespace cvmath
{

	namespace CVElem {
		template <int>	struct CvElemTypeTraits;
		template <>			struct CvElemTypeTraits<CV_32F>		{ typedef float						ElemType; };
		template <>			struct CvElemTypeTraits<CV_64F>		{ typedef double					ElemType; };
		template <>			struct CvElemTypeTraits<CV_32FC3>		{ typedef float						ElemType; };
		template <>			struct CvElemTypeTraits<CV_64FC3>		{ typedef double					ElemType; };
		template <>			struct CvElemTypeTraits<CV_8U>		{ typedef unsigned char		ElemType; };
		template <>			struct CvElemTypeTraits<CV_8S>		{ typedef char						ElemType; };
		template <>			struct CvElemTypeTraits<CV_16U>		{ typedef unsigned short	ElemType; };
		template <>			struct CvElemTypeTraits<CV_16S>		{ typedef short						ElemType; };
		template <>			struct CvElemTypeTraits<CV_32S>		{ typedef long						ElemType; };
	}
}
}